import { ClassDeclaration } from 'ts-morph';
import type { Context } from './context';
import type { Controller } from './Controller';
import type { OperationModel } from '@fresha/openapi-model/build/3.0.3';
/**
 * Generates code for a single NestJS controller action.
 */
export declare class Action {
    readonly context: Context;
    readonly controller: Controller;
    readonly pathUrl: string;
    readonly httpMethod: string;
    private readonly methodName;
    private readonly params;
    private readonly returnSchema;
    private urlSuffix;
    constructor(context: Context, controller: Controller, pathUrl: string, httpMethod: string, operation: OperationModel);
    getUrlSuffix(): string;
    generateCode(classDecl: ClassDeclaration): void;
    private generatePublicMethod;
    private generateHandlerMethod;
}
//# sourceMappingURL=Action.d.ts.map