import type { Context } from './context';
import type { Nullable } from '@fresha/api-tools-core';
import type { SchemaModel } from '@fresha/openapi-model/build/3.0.3';
import type { MethodDeclaration } from 'ts-morph';
/**
 * Generates code for a single parameter of a controller action.
 */
export declare class ActionParam {
    readonly context: Context;
    readonly from: 'body' | 'path' | 'query';
    readonly name: string;
    private readonly schema;
    constructor(context: Context, param: {
        in: 'path' | 'query' | 'body' | 'cookie' | 'header';
        name: string;
        schema: Nullable<SchemaModel>;
    });
    generateCode(methodDecl: MethodDeclaration): void;
}
//# sourceMappingURL=ActionParam.d.ts.map