import { Action } from './Action';
import type { Context } from './context';
import type { PathItemModel } from '@fresha/openapi-model/build/3.0.3';
import type { SourceFile } from 'ts-morph';
/**
 * Generates code for a single NestJS controller.
 */
export declare class Controller {
    /**
     * Given OpenAPI path item URL, returns controller class name.
     */
    static makeClassName(pathUrl: string): string;
    /**
     * Given an OpenAPI path item URL, returns controller file name.
     */
    static makeFileName(pathUrl: string): string;
    readonly context: Context;
    readonly className: string;
    readonly outputPath: string;
    protected readonly sourceFile: SourceFile;
    protected readonly actions: Action[];
    protected urlPrefix: string | null;
    constructor(context: Context, outputPath: string, className: string);
    relativeModulePath(filePath: string): string;
    processPathItem(pathUrl: string, pathItem: PathItemModel): void;
    getUrlPrefix(): string;
    generateCode(): void;
}
//# sourceMappingURL=Controller.d.ts.map