import { Nullable } from '@fresha/api-tools-core';
import type { Context } from './context';
import type { SchemaModel, SchemaPropertyObject } from '@fresha/openapi-model/build/3.0.3';
import type { ClassDeclaration } from 'ts-morph';
export declare class DTO {
    readonly context: Context;
    readonly className: string;
    readonly outputPath: string;
    private readonly schema;
    private readonly sourceFile;
    constructor(context: Context, name: string, schema: Nullable<SchemaModel>);
    generateCode(): void;
    protected addClassDecl(className: string, schema: Nullable<SchemaModel>): void;
    protected addUnknownProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
    protected addBooleanProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
    protected addNumericProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
    protected addStringProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
    protected addObjectProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
    protected addArrayProperty(classDecl: ClassDeclaration, prop: SchemaPropertyObject): void;
}
//# sourceMappingURL=DTO.d.ts.map