import { Generator as GeneratorBase } from '@fresha/openapi-codegen-utils';
import { Controller } from './Controller';
import { DTO } from './DTO';
import { Module } from './Module';
import type { Context } from './context';
import type { Nullable } from '@fresha/api-tools-core';
import type { PathItemModel, SchemaModel } from '@fresha/openapi-model/build/3.0.3';
export declare class Generator extends GeneratorBase<Context> {
    protected readonly controllers: Map<string, Controller>;
    protected readonly dtos: Map<string, DTO>;
    protected readonly module: Module;
    constructor(context: Context);
    get outputPath(): string;
    get nestApp(): string;
    getDTO(name: string): DTO | undefined;
    addDTO(name: string, schema: Nullable<SchemaModel>): DTO;
    protected collectData(): void;
    protected processPathItem(pathUrl: string, pathItem: PathItemModel): void;
    generateCode(): void;
}
//# sourceMappingURL=Generator.d.ts.map